unit HiTempFont;

//HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion\Fonts
interface

uses Windows,Messages,kol,Share,Debug;

type
 THiTempFont = class(TDebug)
   private
     fFontFile:string;
     fFontName:string;
     P:PStream;
     IStream:boolean;
     procedure wrPStream(X:PStream);
   public

    _prop_FileName:string;
    
    _data_FileName: THI_Event;
    _event_onInstall: THI_Event;

    constructor Create;
    destructor Destroy; override;
    procedure _work_doInstall(var _Data:TData; Index:word);
    procedure _work_doInstallfromStream(var _Data:TData; Index:word);
    procedure _var_FontName(var _Data:TData; Index:word);
    property _prop_FontStream:PStream write wrPStream;            
 end;
implementation

function StringToWideString(const s: String; codePage: Word): WideString;
var   len: integer;
begin
   Result := '';
   if s = '' then exit;
   len := MultiByteToWideChar(codePage, MB_PRECOMPOSED, PChar(@s[1]), -1, nil, 0);
   SetLength(Result, len - 1);
   if len <= 1 then exit;
   MultiByteToWideChar(CodePage, MB_PRECOMPOSED, PChar(@s[1]), -1, PWideChar(@Result[1]), len);
end;

function GetFontName (FontFileA : string) : String;
type
   TGetFontResourceInfoW = function (FontPath : PWideChar; var BufSize : DWORD; FontName : PWideChar; dwFlags : DWORD) : DWORD; stdcall;
var
      GetFontResourceInfoW : TGetFontResourceInfoW;
      FontFileW : PWideChar;
      FontNameW : PWideChar;
      FontNameSize : DWORD;

begin
   Result := '';
   GetFontResourceInfoW := GetProcAddress(GetModuleHandle('gdi32.dll'), 'GetFontResourceInfoW');
   if @GetFontResourceInfoW = nil then Exit;
   FontFileW := PWChar(StringToWideString(FontFileA,3));
   FontNameSize := 0;
   FontNameW := nil;
   GetFontResourceInfoW (FontFileW, FontNameSize, FontNameW, 1);
   GetMem (FontNameW, FontNameSize);
   FontNameW^ := #0; //   - 
   GetFontResourceInfoW (FontFileW, FontNameSize, FontNameW, 1);
   Result := FontNameW;
end;

constructor THiTempFont.Create;
begin
  inherited;
  P:=NewMemoryStream;
  IStream := false;
end;

procedure THiTempFont.wrPStream;
begin
  P.free;
  P := X;
end;

destructor THiTempFont.Destroy;
begin
   if fFontFile <> '' then begin
      RemoveFontResource(PChar(fFontFile));
      SendMessage(HWND_BROADCAST, WM_FONTCHANGE, 0, 0);
   end;
   If IStream and (fFontFile <> '') and FileExists(fFontFile) then DeleteFiles(PChar(fFontFile));
   P.free;
   inherited;
end;

procedure THiTempFont._work_doInstall;
var   s: string;
      len: dword;
      fn: pchar;
      sfnt:integer;
begin
   IStream := false;
   if WinVer < wvNT then exit;
   if fFontFile <> '' then begin
      RemoveFontResource(PChar(fFontFile));
      SendMessage(HWND_BROADCAST, WM_FONTCHANGE, 0, 0);
   end;
   fFontFile := '';
   fFontName := '';   
   if Index = 0 then
      s := ToString(_Data)
   else    
      s := ReadString(_Data, _data_FileName, _prop_FileName);
   len := GetFullPathName(@s[1],0,nil,fn);
   setlength(fFontFile,len-1);
   GetFullPathName(@s[1], len, @fFontFile[1], fn);
   if not FileExists(fFontFile) then exit;
   sfnt := AddFontResource(PChar(fFontFile));
   if sfnt <> 0 then begin 
      fFontName := GetFontName(fFontFile);
      SendMessage(HWND_BROADCAST, WM_FONTCHANGE, 0, 0);
   end;   
   _hi_onEvent(_event_onInstall, sfnt);
end;

procedure THiTempFont._work_doInstallfromStream;
var   FontStream: PStream;
      s, s1: string;
      len: dword;
      fn: pchar;
      dt :TData;
begin
   if P.Size = 0 then exit;
   P.Position := 0;
   s := ReadString(_Data, _data_FileName, _prop_FileName);
   len := GetFullPathName(@s[1],0,nil,fn);
   setlength(s1,len-1);
   GetFullPathName(@s[1], len, @s1[1], fn);
   if FileExists(s1) then DeleteFiles(PChar(s1));
   FontStream := NewWriteFileStream(s1);
   Stream2Stream(FontStream,P,P.Size);
   free_and_nil(FontStream);
   if not FileExists(s1) then exit;  
   SetFileAttributes(PChar(s1),2);
   dtString(dt, s1);
   _work_doInstall(dt,0);
   IStream := true;
end;

procedure THiTempFont._var_FontName;
begin
   dtString(_Data, fFontName);
end;

end.